searchData={"items":[{"type":"behaviour","title":"Conpipe.Converter","doc":"Behavior for Conpipe Connectors","ref":"Conpipe.Converter.html"},{"type":"callback","title":"Conpipe.Converter.convert/2","doc":"","ref":"Conpipe.Converter.html#c:convert/2"},{"type":"module","title":"Conpipe.Converter.Earmark","doc":"This converter uses the `Earmark` conversion engine to transform markdown to HTML.\n\nSee the [Earmark Repo](https://hexdocs.pm/earmark/Earmark.html) for more info.","ref":"Conpipe.Converter.Earmark.html"},{"type":"function","title":"Conpipe.Converter.Earmark.convert/1","doc":"The `convert/1` function simply takes a string and returns a converted\nstringk","ref":"Conpipe.Converter.Earmark.html#convert/1"},{"type":"function","title":"Conpipe.Converter.Earmark.convert/2","doc":"Convert Markdown to HTML using Earmark","ref":"Conpipe.Converter.Earmark.html#convert/2"},{"type":"function","title":"Conpipe.Converter.Earmark.convert/4","doc":"The `convert/4` function can be called directly from Tableau.\n\n```elixir\n# config/config.exs\nconfig :tableau, :config,\n  url: \"http://localhost:4999\",\n  converters: [\n    md: Conpipe.Converter.Earmark\n  ]\n```\n\nThe `convert/4` function returns just the converted text. It should not\nbe used in a pipeline.","ref":"Conpipe.Converter.Earmark.html#convert/4"},{"type":"module","title":"Conpipe.Converter.Eex","doc":"This converter uses the `EEx` template engine to transform EEx tags.\n\nSee [EEx Hexdocs](https://hexdocs.pm/eex/1.14/EEx.html) for more info.","ref":"Conpipe.Converter.Eex.html"},{"type":"function","title":"Conpipe.Converter.Eex.convert/1","doc":"The `convert/1` function simply takes a string and returns a converted\nstringk","ref":"Conpipe.Converter.Eex.html#convert/1"},{"type":"function","title":"Conpipe.Converter.Eex.convert/2","doc":"Resolve EEx tags","ref":"Conpipe.Converter.Eex.html#convert/2"},{"type":"function","title":"Conpipe.Converter.Eex.convert/4","doc":"The `convert/4` function can be called directly from Tableau.\n\n```elixir\n# config/config.exs\nconfig :tableau, :config,\n  url: \"http://localhost:4999\",\n  converters: [\n    md: Conpipe.Converter.Eex\n  ]\n```\n\nThe `convert/4` function returns just the converted text. It should not\nbe used in a pipeline.","ref":"Conpipe.Converter.Eex.html#convert/4"},{"type":"module","title":"Conpipe.Converter.Mdex","doc":"This converter uses the `MDEx` template engine to transform markdown to HTML.\n\nSee the [MDEx](https://github.com/edgurgel/solid) repo for more information.","ref":"Conpipe.Converter.Mdex.html"},{"type":"function","title":"Conpipe.Converter.Mdex.convert/1","doc":"The `convert/1` function simply takes a string and returns a converted\nstringk","ref":"Conpipe.Converter.Mdex.html#convert/1"},{"type":"function","title":"Conpipe.Converter.Mdex.convert/2","doc":"Convert Markdown to HTML using MDEx","ref":"Conpipe.Converter.Mdex.html#convert/2"},{"type":"function","title":"Conpipe.Converter.Mdex.convert/4","doc":"The `convert/4` function can be called directly from Tableau.\n\n```elixir\n# config/config.exs\nconfig :tableau, :config,\n  url: \"http://localhost:4999\",\n  converters: [\n    md: Conpipe.Converter.Mdex\n  ]\n```\n\nThe `convert/4` function returns just the converted text. It should not\nbe used in a pipeline.","ref":"Conpipe.Converter.Mdex.html#convert/4"},{"type":"module","title":"Conpipe.Converter.Netlify","doc":"This is an experimental converter, that post-processes HTML to rewrite image\nURLs to use Netlify.\n\nSee the Tableau issue https://github.com/elixir-tools/tableau/issues/107 for\nmore background.\n\nThis use case derives from @paradox460's Netlify processor at\n  https://github.com/elixir-tools/tableau/issues/107\n\nTo use, put this converter LAST in the Pipeline, after HTML conversion.","ref":"Conpipe.Converter.Netlify.html"},{"type":"function","title":"Conpipe.Converter.Netlify.convert/1","doc":"The `convert/1` function simply takes a string and returns a converted\nstringk","ref":"Conpipe.Converter.Netlify.html#convert/1"},{"type":"function","title":"Conpipe.Converter.Netlify.convert/2","doc":"Perform HTML post-processing for Netlify image links","ref":"Conpipe.Converter.Netlify.html#convert/2"},{"type":"function","title":"Conpipe.Converter.Netlify.convert/4","doc":"The `convert/4` function can be called directly from Tableau.\n\n```elixir\n# config/config.exs\nconfig :tableau, :config,\n  url: \"http://localhost:4999\",\n  converters: [\n    md: Conpipe.Converter.Netlify\n  ]\n```\n\nThe `convert/4` function returns just the converted text. It should not\nbe used in a pipeline.","ref":"Conpipe.Converter.Netlify.html#convert/4"},{"type":"module","title":"Conpipe.Converter.Noop","doc":"This converter passes `{input, assigns}` thru unchanged.\n\nUsed for testing.","ref":"Conpipe.Converter.Noop.html"},{"type":"function","title":"Conpipe.Converter.Noop.convert/1","doc":"The `convert/1` function simply takes a string and returns a converted\nstringk","ref":"Conpipe.Converter.Noop.html#convert/1"},{"type":"function","title":"Conpipe.Converter.Noop.convert/2","doc":"No-op module used for testing","ref":"Conpipe.Converter.Noop.html#convert/2"},{"type":"function","title":"Conpipe.Converter.Noop.convert/4","doc":"The `convert/4` function can be called directly from Tableau.\n\n```elixir\n# config/config.exs\nconfig :tableau, :config,\n  url: \"http://localhost:4999\",\n  converters: [\n    md: Conpipe.Converter.Noop\n  ]\n```\n\nThe `convert/4` function returns just the converted text. It should not\nbe used in a pipeline.","ref":"Conpipe.Converter.Noop.html#convert/4"},{"type":"module","title":"Conpipe.Converter.Solid","doc":"This converter uses the `Solid` template engine to transform Liquid tags.\n\nSee the [Solid](https://github.com/leandrocp/mdex) repo for more information.","ref":"Conpipe.Converter.Solid.html"},{"type":"function","title":"Conpipe.Converter.Solid.convert/1","doc":"The `convert/1` function simply takes a string and returns a converted\nstringk","ref":"Conpipe.Converter.Solid.html#convert/1"},{"type":"function","title":"Conpipe.Converter.Solid.convert/2","doc":"Resolve liquid tags using Solid\n\nIf there are syntax errors in the Liquid tags, the input text will returned as-is,\nwith an error message pre-pended in the first line.","ref":"Conpipe.Converter.Solid.html#convert/2"},{"type":"function","title":"Conpipe.Converter.Solid.convert/4","doc":"The `convert/4` function can be called directly from Tableau.\n\n```elixir\n# config/config.exs\nconfig :tableau, :config,\n  url: \"http://localhost:4999\",\n  converters: [\n    md: Conpipe.Converter.Solid\n  ]\n```\n\nThe `convert/4` function returns just the converted text. It should not\nbe used in a pipeline.","ref":"Conpipe.Converter.Solid.html#convert/4"},{"type":"module","title":"Conpipe.Converter.SolidMdex","doc":"This converter consumes Markdown text with embedded Liquid tags.\n\nIt uses the `Conpipe.Convert.Solid` to transform the Liquid tags,\nand `Conpipe.Convert.Mdex` to transform Markdown to HTML.","ref":"Conpipe.Converter.SolidMdex.html"},{"type":"function","title":"Conpipe.Converter.SolidMdex.convert/1","doc":"The `convert/1` function simply takes a string and returns a converted\nstringk","ref":"Conpipe.Converter.SolidMdex.html#convert/1"},{"type":"function","title":"Conpipe.Converter.SolidMdex.convert/2","doc":"Convert Liquid tags then convert markdown to HTML","ref":"Conpipe.Converter.SolidMdex.html#convert/2"},{"type":"function","title":"Conpipe.Converter.SolidMdex.convert/4","doc":"The `convert/4` function can be called directly from Tableau.\n\n```elixir\n# config/config.exs\nconfig :tableau, :config,\n  url: \"http://localhost:4999\",\n  converters: [\n    md: Conpipe.Converter.SolidMdex\n  ]\n```\n\nThe `convert/4` function returns just the converted text. It should not\nbe used in a pipeline.","ref":"Conpipe.Converter.SolidMdex.html#convert/4"},{"type":"module","title":"Conpipe.Runner","doc":"Functions to run a pipeline","ref":"Conpipe.Runner.html"},{"type":"function","title":"Conpipe.Runner.exec/3","doc":"Exec a pipeline\n\nReturns `output`","ref":"Conpipe.Runner.html#exec/3"},{"type":"function","title":"Conpipe.Runner.reduce/3","doc":"Reduce over a pipeline\n\nReturns `{output, assigns}`","ref":"Conpipe.Runner.html#reduce/3"},{"type":"module","title":"Conpipe.Util","doc":"Utility functions for Conpipe operations.","ref":"Conpipe.Util.html"},{"type":"function","title":"Conpipe.Util.stringify_keys/1","doc":"Recursively converts all atom keys to strings.","ref":"Conpipe.Util.html#stringify_keys/1"},{"type":"extras","title":"Conpipe","doc":"# Conpipe \n\nA Converter Pipeline with a composable library of operations. Conpipe wraps\ntemplate processors (eg EEx, Liquid) and plain-text markup languages (eg\nMarkdown, Asciidoc).  Conpipe is:\n\n- intended for use in Static Site Generators like\n[Tableau](https://github.com/elixir-tools/tableau) \n- designed to be extended","ref":"readme.html"},{"type":"extras","title":"Installation - Conpipe","doc":"Add `conpipe` to your list of dependencies in `mix.exs`:\n\n```elixir\ndef deps do\n  [\n    {:conpipe, \"~> 0.1.0\"}\n  ]\nend\n```\n\nOnline docs are at  .","ref":"readme.html#installation"},{"type":"extras","title":"Converters - Conpipe","doc":"A converter is a module with a `convert/2` function that implements the\n`Conpipe.Converter` behavior.  Here's a converter that processes Liquid tags:\n\n```elixir \ndefmodule MyLiquidConverter do\n  @behavior Conpipe.Converter \n\n  def convert({text, assigns}, opts \\\\ []) do\n    {:ok, template} = Solid.parse(text, opts)\n    output = Solid.render!(template, assigns) |> to_string\n    {output, assigns}\n  end\nend\n```\n\nConverters can be chained in Elixir pipes:\n\n```elixir\ndefmodule My.DoItAllConverter do \n  @behavior Conpipe.Converter \n\n  def convert({text, assigns}, _opts \\\\ []) do \n    {text, assigns} \n    |> Conpipe.Converter.Solid.convert()\n    |> MyConverter.convert()\n    |> Conpipe.Converter.Mdex.convert()\n    |> MyHtmlPostProcessor.convert()\n  end\nend\n```\n\nConverters can be composed and run in a pipeline:\n\n```elixir\n[Conpipe.Converter.Solid, MyConverter, Conpipe.Converter.Mdex] \n|> Conpipe.Runner.reduce(text, assigns)\n```\n\nThis project ships with a library of converters that can be reused across applications: \n\nMarkup Languages\n- `Conpipe.Converter.Earmark` - Markdown HTML\n- `Conpipe.Converter.Mdex` - Markdown to HTML\n \nTemplate Processors \n- `Conpipe.Converter.Eex` - EEx template language \n- `Conpipe.Converter.Solid` - Liquid template language \n\nFind an up-to-date list of converters in the [online\ndocumentation](https://hexdocs.pm/conpipe/readme.html).","ref":"readme.html#converters"},{"type":"extras","title":"Tableau Integration - Conpipe","doc":"Adding `use Conpipe.Extended` to a converter provides a `convert/4`\nfunction that can be called directly from Tableau.\n\n```elixir \ndefmodule MyConverter do \n  @behavior Conpipe.Converter \n  use Conpipe.Extended \n\n  def convert({text, assigns}, _opts \\\\ []) do \n    {text, assigns} \n    |> Conpipe.Converter.Solid.convert()\n    |> Conpipe.Converter.Mdex.convert()\n  end\nend\n```\n\nThen in `config/config.exs` \n\n```elixir \nconfig :tableau, :config,\n  url: \"http://localhost:4999\",\n  converters: [\n    md: MyConverter\n  ]\n```\n\nAll converters in this package use `TableauAdapter`.","ref":"readme.html#tableau-integration"},{"type":"extras","title":"Contributions - Conpipe","doc":"Pull Requests welcome!  PR's require [Conventional\nCommits](https://www.conventionalcommits.org/en/v1.0.0/), passing tests and\nformatted code. \n\nPre-commit hooks and setup scripts can be found in `.github/hooks`.","ref":"readme.html#contributions"},{"type":"extras","title":"Change Log","doc":"# Change Log\n\nAll notable changes to this project will be documented in this file.\nSee [Conventional Commits](Https://conventionalcommits.org) for commit guidelines.\n\n<!-- changelog -->\n\n## [v0.1.0](https://github.com/andyl/conpipe/compare/v0.0.5...v0.1.0) (2024-10-19)","ref":"changelog.html"},{"type":"extras","title":"Features: - Change Log","doc":"* add Conpipe.Extended\n\n## [v0.0.5](https://github.com/andyl/conpipe/compare/v0.0.4...v0.0.5) (2024-10-19)","ref":"changelog.html#features"},{"type":"extras","title":"Bug Fixes: - Change Log","doc":"* handle invalid templates (#8)\n\n## [v0.0.4](https://github.com/andyl/conpipe/compare/v0.0.3...v0.0.4) (2024-10-18)","ref":"changelog.html#bug-fixes"},{"type":"extras","title":"Bug Fixes: - Change Log","doc":"* remove test messages\n\n## [v0.0.3](https://github.com/andyl/conpipe/compare/v0.0.2...v0.0.3) (2024-10-18)","ref":"changelog.html#bug-fixes"},{"type":"extras","title":"Bug Fixes: - Change Log","doc":"* generate list of commit messages\n\n## [v0.0.2](https://github.com/andyl/conpipe/compare/v0.0.1...v0.0.2) (2024-10-18)\n\n## [v0.0.1](https://github.com/andyl/conpipe/compare/v0.0.1...v0.0.1) (2024-10-18)","ref":"changelog.html#bug-fixes"},{"type":"extras","title":"Bug Fixes: - Change Log","doc":"* change application version","ref":"changelog.html#bug-fixes"}],"content_type":"text/markdown","producer":{"name":"ex_doc","version":[48,46,51,52,46,50]}}